#######################################################################
#
#    Weather for Enigma2
#    Coded by shamann (c)2013
#
#    inspired by 2boom's YWeather
#    xml from http://weather.yahooapis.com/forecastrss
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License
#    as published by the Free Software Foundation; either version 2
#    of the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#######################################################################
from Screens.Screen import Screen
from Components.Label import Label
from Components.Pixmap import Pixmap
from Tools.Directories import fileExists
import time
import os
from Components.config import config
from skin import parseColor
import gettext
from socket import socket, AF_INET, SOCK_STREAM
from urllib2 import Request, urlopen
#######################################################################
PLUGINPATH = "/usr/lib/enigma2/python/Plugins/Extensions/setupGlass16/"
try:
	if config.plugins.setupGlass16.par49.value:
		weather_language = []
		weather_language = config.osd.language.value.split("_")
		if os.path.exists(PLUGINPATH + "locale/%s" % (weather_language[0])):
			_ = gettext.Catalog('weather', PLUGINPATH + 'locale', weather_language).gettext
except: pass
#######################################################################
LIGHT = False
try:
	if "light" in config.plugins.setupGlass16.par12.value or "light" in config.plugins.setupGlass16.par31.value or "light" in config.plugins.setupGlass16.par78.value:
		LIGHT = True
except: pass
#######################################################################
XML_FILE = "/tmp/weather.xml"
NO_WEATHER_PICON = "/usr/share/enigma2/hd_glass16/icons/3200.png"
NO_WIND_PICON = "/usr/share/enigma2/hd_glass16/icons/no-wind.png"
UNKNOWN_STATE = _("...N/A...")
UNKNOWN_STATE_TEMP = "--" + '%s' % unichr(176).encode("latin-1")
RESET_VALUES = UNKNOWN_STATE+"\n"+UNKNOWN_STATE+"\n"+UNKNOWN_STATE+"\n"+UNKNOWN_STATE+"\n"+UNKNOWN_STATE+"\n"+UNKNOWN_STATE+"\n"+UNKNOWN_STATE+ "%s" % ({True:"\n"+UNKNOWN_STATE, False:""}[LIGHT])
LEASE_TIME = 15
ALL_ITEMS = "%s" % ({False:_("City")+":\n"+_("Country")+":\n", True:""}[LIGHT]) +_("Wind")+":\n"+_("Wind direction")+":\n"+_("Humidity")+":\n"+_("Visibility")+":\n"+_("Pressure")+":"+ "%s" % ({True:"\n"+_("Sunrise")+":\n"+_("Sunset")+":\n"+_("Update")+":", False:""}[LIGHT])
DICT_DAYS = {'Sun':_('Sun'), 'Mon':_('Mon'), 'Tue':_('Tue'), 'Wed':_('Wed'), 'Thu':_('Thu'), 'Fri':_('Fri'), 'Sat':_('Sat')}
DICT_DATE = {'Jan':_('January'), 'Feb':_('February'), 'Mar':_('March'), 'Apr':_('April'), 'May':_('May'), 'Jun':_('Jun'), 'Jul':_('Jul'), 'Aug':_('August'), 'Sep':_('September'), 'Oct':_('October'), 'Nov':_('November'), 'Dec':_('December')}
DICT_TEXT = {'Light Snow':_('Light Snow Shower'), 'Snow Showers':_('Light Snow Shower'), 'Fog':_('Fog'), 'Sun':_('Sunny'), 'Clouds':_('Cloudy'), 'Light Rain with Thunder':_('Light Rain with Thunder'), 'Drizzle':_('Drizzle'), 'Showers in the Vicinity':_('Showers in the Vicinity'),
'Rain Shower':_('Rain Shower'), 'Thunderstorm':_('Thunderstorm'), 'Thunder in the Vicinity':_('Thunder in the Vicinity'), 'Thundershowers':_('Thundershowers'), 'Light Drizzle':_('Light Drizzle'), 'Thunder':_('Thunder'), 'Light Rain Shower':_('Light Rain Shower'),
'Isolated Thunderstorms':_('Isolated Thunderstorms'), 'Scattered Thunderstorms':_('Scattered Thunderstorms'), 'AM':_('AM'), 'PM':_('PM'), 'Mostly Clear':_('Mostly Clear'), 'Snow':_('Snow'), 'Thunderstorms':_('Thunderstorms'), 'Wind':_('Wind'), 'Windy':_('Wind'), 'T-Storms':_('Thunderstorms'),
'Showers':_('Showers'), 'Light Snow Shower':_('Light Snow Shower'), 'Rain':_('Rain'), 'Mostly Sunny':_('Mostly Sunny'), 'Sunny':_('Sunny'), 'Clearing':_('Clear'), 'Clear':_('Clear'), 'Thunderstorms':_('Thunderstorms'), 'Partly Cloudy':_('Partly Cloudy'), 'Mostly Cloudy':_('Mostly Cloudy'),
'Scattered Showers':_('Scattered Showers'), 'Few Showers':_('Few Showers'), 'Light Rain':_('Light Rain'), 'Showers':_('Showers'), 'Cloudy':_('Cloudy'), 'Fair':_('Fair'), 'Scattered Snow Showers':_('Scattered Snow Showers'), 'Wintry Mix':_('Wintry Mix'), 'Icy':_('Ice'), 'Ice':_('Ice'), 'Heavy Rain':_('Rain')}
#######################################################################
class ColorLabel(Label):
	def __init__(self, text=""):
		Label.__init__(self, text)

	def color0(self):
		if self.instance:
			self.instance.setForegroundColor(parseColor("#CC99CC")) # -10

	def color1(self):
		if self.instance:
			self.instance.setForegroundColor(parseColor("#9966FF")) # -5

	def color2(self):
		if self.instance:
			self.instance.setForegroundColor(parseColor("#3399FF")) # 0

	def color3(self):
		if self.instance:
			self.instance.setForegroundColor(parseColor("#99CCFF")) # 5

	def color4(self):
		if self.instance:
			self.instance.setForegroundColor(parseColor("#66CC66")) # 10

	def color5(self):
		if self.instance:
			self.instance.setForegroundColor(parseColor("#FFFF99")) # 15
			
	def color6(self):
		if self.instance:
			self.instance.setForegroundColor(parseColor("#FFCC33")) # 20

	def color7(self):
		if self.instance:
			self.instance.setForegroundColor(parseColor("#FF9933")) # 25

	def color8(self):
		if self.instance:
			self.instance.setForegroundColor(parseColor("#FF6600")) # 30

	def color9(self):
		if self.instance:
			self.instance.setForegroundColor(parseColor("#FF0000")) # 35
			
	def color10(self):
		if self.instance:
			self.instance.setForegroundColor(parseColor("#990000")) # 40
#######################################################################
class WeatherScreen(Screen):                  

	skin = """<screen name="WeatherScreen" position="430,109" size="785,325" title="Weather" zPosition="8" backgroundColor="#31000000" >                                           

<widget name="Weather_items" font="Prive3;17" position="0,0" zPosition="2" size="165,200" valign="top" halign="right" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_values" font="Prive3;17" position="175,0" zPosition="3" size="200,200" valign="top" halign="left"  backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon0" pixmap="hd_glass16/icons/3200.png" position="355,35" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperature0" font="Prive3;21" position="316,112" zPosition="2" size="150,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state0" font="Prive3;16" position="316,0" zPosition="3" size="150,35" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<ePixmap position="5,142" zPosition="7" size="560,2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/setupGlass16/tib2.png" alphatest="on"/>
<ePixmap position="565,142" zPosition="7" size="215,2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/setupGlass16/tib2.png" alphatest="on"/>
<widget name="Weather_wind" pixmap="hd_glass16/icons/no-wind.png" position="475,0" zPosition="5" size="140,140" alphatest="on" />
<widget name="Weather_wind_label" font="Prive3;18" position="472,5" zPosition="2" size="0,0" valign="center" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_sunrise" font="Prive3;16" position="625,52" zPosition="5" size="150,20" valign="top" halign="center" foregroundColor="#ffcc00" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_sunset" font="Prive3;16" position="625,124" zPosition="5" size="150,20" valign="top" halign="center" foregroundColor="#ff3300" backgroundColor="#31000000" transparent="1" />
<ePixmap position="650,0" zPosition="6" size="99,50" pixmap="hd_glass16/icons/Sunrise-fs8.png" alphatest="on"/>
<ePixmap position="650,72" zPosition="6" size="99,50" pixmap="hd_glass16/icons/Sunset-fs8.png" alphatest="on"/>

<widget name="Weather_picon1" pixmap="hd_glass16/icons/3200.png" position="45,185" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperaturelow1" font="Prive3;21" position="15,260" zPosition="2" size="65,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature1" font="Prive3;21" position="80,260" zPosition="2" size="65,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state1" font="Prive3;16" position="5,150" zPosition="3" size="150,35" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date1" font="Prive3;16" position="5,285" zPosition="3" size="150,35" valign="top" halign="center"  foregroundColor="#CC3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon2" pixmap="hd_glass16/icons/3200.png" position="200,185" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperaturelow2" font="Prive3;21" position="170,260" zPosition="2" size="65,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature2" font="Prive3;21" position="235,260" zPosition="2" size="65,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state2" font="Prive3;16" position="160,150" zPosition="3" size="150,35" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date2" font="Prive3;16" position="160,285" zPosition="3" size="150,35" valign="top" halign="center"  foregroundColor="#CC3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon3" pixmap="hd_glass16/icons/3200.png" position="355,185" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperaturelow3" font="Prive3;21" position="325,260" zPosition="2" size="65,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature3" font="Prive3;21" position="390,260" zPosition="2" size="65,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state3" font="Prive3;16" position="315,150" zPosition="3" size="150,35" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date3" font="Prive3;16" position="315,285" zPosition="3" size="150,35" valign="top" halign="center"  foregroundColor="#CC3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon4" pixmap="hd_glass16/icons/3200.png" position="510,185" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperaturelow4" font="Prive3;21" position="480,260" zPosition="2" size="65,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature4" font="Prive3;21" position="545,260" zPosition="2" size="65,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state4" font="Prive3;16" position="470,150" zPosition="3" size="150,35" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date4" font="Prive3;16" position="470,285" zPosition="3" size="150,35" valign="top" halign="center"  foregroundColor="#CC3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon5" pixmap="hd_glass16/icons/3200.png" position="665,185" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperaturelow5" font="Prive3;21" position="635,260" zPosition="2" size="65,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature5" font="Prive3;21" position="700,260" zPosition="2" size="65,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state5" font="Prive3;16" position="625,150" zPosition="3" size="150,35" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date5" font="Prive3;16" position="625,285" zPosition="3" size="150,35" valign="top" halign="center"  foregroundColor="#CC3399" backgroundColor="#31000000" transparent="1" />

</screen>"""

	skinB = """<screen name="WeatherScreen" position="center,80" size="1030,430" zPosition="8" title="Weather" backgroundColor="#31000000" >                                           

<widget name="Weather_items" font="Prive3;22" position="0,10" zPosition="2" size="207,200" valign="top" halign="right" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_values" font="Prive3;22" position="217,10" zPosition="3" size="300,200" valign="top" halign="left"  backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon0" pixmap="hd_glass16/icons/3200.png" position="480,60" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperature0" font="Prive3;25" position="415,145" zPosition="2" size="200,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state0" font="Prive3;22" position="415,5" zPosition="3" size="200,50" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<ePixmap position="5,193" zPosition="7" size="560,2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/setupGlass16/tib2.png" alphatest="on"/>
<ePixmap position="565,193" zPosition="7" size="460,2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/setupGlass16/tib2.png" alphatest="on"/>
<widget name="Weather_wind" pixmap="hd_glass16/icons/no-wind.png" position="650,40" zPosition="5" size="140,140" alphatest="on" />
<widget name="Weather_wind_label" font="Prive3;22" position="570,5" zPosition="2" size="300,30" valign="center" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_sunrise" font="Prive3;22" position="850,68" zPosition="5" size="150,25" valign="top" halign="center" foregroundColor="#ffcc00" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_sunset" font="Prive3;22" position="850,158" zPosition="5" size="150,25" valign="top" halign="center" foregroundColor="#ff3300" backgroundColor="#31000000" transparent="1" />
<ePixmap position="875,10" zPosition="6" size="99,50" pixmap="hd_glass16/icons/Sunrise-fs8.png" alphatest="on"/>
<ePixmap position="875,100" zPosition="6" size="99,50" pixmap="hd_glass16/icons/Sunset-fs8.png" alphatest="on"/>

<widget name="Weather_picon1" pixmap="hd_glass16/icons/3200.png" position="70,255" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperaturelow1" font="Prive3;24" position="30,330" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature1" font="Prive3;25" position="105,330" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state1" font="Prive3;22" position="5,202" zPosition="3" size="200,50" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date1" font="Prive3;22" position="5,360" zPosition="3" size="200,50" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon2" pixmap="hd_glass16/icons/3200.png" position="275,255" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperaturelow2" font="Prive3;24" position="235,330" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature2" font="Prive3;25" position="310,330" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state2" font="Prive3;22" position="210,202" zPosition="3" size="200,50" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date2" font="Prive3;22" position="210,360" zPosition="3" size="200,50" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon3" pixmap="hd_glass16/icons/3200.png" position="480,255" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperaturelow3" font="Prive3;24" position="440,330" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature3" font="Prive3;25" position="515,330" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state3" font="Prive3;22" position="415,202" zPosition="3" size="200,50" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date3" font="Prive3;22" position="415,360" zPosition="3" size="200,50" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon4" pixmap="hd_glass16/icons/3200.png" position="685,255" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperaturelow4" font="Prive3;24" position="645,330" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature4" font="Prive3;25" position="720,330" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state4" font="Prive3;22" position="620,202" zPosition="3" size="200,50" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date4" font="Prive3;22" position="620,360" zPosition="3" size="200,50" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon5" pixmap="hd_glass16/icons/3200.png" position="890,255" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_Temperaturelow5" font="Prive3;24" position="850,330" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature5" font="Prive3;25" position="925,330" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state5" font="Prive3;22" position="825,202" zPosition="3" size="200,50" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date5" font="Prive3;22" position="825,360" zPosition="3" size="200,50" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

</screen>"""

	skinLight = """<screen name="WeatherScreen" position="center,80" size="660,430" zPosition="8" title="Weather" backgroundColor="#31000000" >                                           
<widget name="Weather_sunrise" font="Prive3;22" position="850,158" zPosition="5" size="0,0" valign="top" halign="center" foregroundColor="#66CCFF" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_wind" pixmap="hd_glass16/icons/no-wind.png" position="650,40" zPosition="5" size="0,0" alphatest="on" />
<widget name="Weather_wind_label" font="Prive3;22" position="570,5" zPosition="2" size="0,0" valign="center" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_picon1" pixmap="hd_glass16/icons/3200.png" position="70,255" zPosition="5" size="0,0" alphatest="on" />
<widget name="Weather_state1" font="Prive3;22" position="5,202" zPosition="3" size="0,0" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date1" font="Prive3;22" position="5,360" zPosition="3" size="0,0" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_sunset" font="Prive3;25" position="10,10" zPosition="2" size="207,30" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature0" font="Prive3;50" position="10,45" zPosition="2" size="100,60" valign="top" halign="left" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_picon0" pixmap="hd_glass16/icons/3200.png" position="130,45" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_state0" font="Prive3;22" position="10,120" zPosition="3" size="200,50" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<eLabel text="Max:" font="Prive3;20" position="10,170" zPosition="2" size="50,40" valign="top" halign="left" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature1" font="Prive3;20" position="70,170" zPosition="2" size="70,40" valign="top" halign="left" foregroundColor="red" backgroundColor="#31000000" transparent="1" />
<eLabel text="Min:" font="Prive3;20" position="130,170" zPosition="2" size="50,40" valign="top" halign="left" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperaturelow1" font="Prive3;20" position="190,170" zPosition="2" size="75,40" valign="top" halign="left" foregroundColor="blue" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_items" font="Prive3;22" position="250,5" zPosition="2" size="207,230" valign="top" halign="right" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_values" font="Prive3;22" position="467,5" zPosition="3" size="300,230" valign="top" halign="left"  backgroundColor="#31000000" transparent="1" />

<ePixmap position="5,215" zPosition="7" size="560,2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/setupGlass16/tib2.png" alphatest="on"/>
<ePixmap position="565,215" zPosition="7" size="460,2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/setupGlass16/tib2.png" alphatest="on"/>


<widget name="Weather_state2" font="Prive3;22" position="10,230" zPosition="3" size="200,50" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_picon2" pixmap="hd_glass16/icons/3200.png" position="10,283" zPosition="5" size="72,72" alphatest="on" />
<ePixmap position="90,290" zPosition="7" size="19,16" pixmap="hd_glass16/icons/up.png" alphatest="on"/>
<widget name="Weather_Temperature2" font="Prive3;25" position="115,283" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<ePixmap position="90,325" zPosition="7" size="19,16" pixmap="hd_glass16/icons/down.png" alphatest="on"/>
<widget name="Weather_Temperaturelow2" font="Prive3;24" position="115,318" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date2" font="Prive3;22" position="10,360" zPosition="3" size="200,50" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_state3" font="Prive3;22" position="235,230" zPosition="3" size="200,50" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_picon3" pixmap="hd_glass16/icons/3200.png" position="235,283" zPosition="5" size="72,72" alphatest="on" />
<ePixmap position="315,290" zPosition="7" size="19,16" pixmap="hd_glass16/icons/up.png" alphatest="on"/>
<widget name="Weather_Temperature3" font="Prive3;25" position="340,283" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<ePixmap position="315,325" zPosition="7" size="19,16" pixmap="hd_glass16/icons/down.png" alphatest="on"/>
<widget name="Weather_Temperaturelow3" font="Prive3;24" position="340,318" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date3" font="Prive3;22" position="235,360" zPosition="3" size="200,50" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_state4" font="Prive3;22" position="450,230" zPosition="3" size="200,50" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_picon4" pixmap="hd_glass16/icons/3200.png" position="450,283" zPosition="5" size="72,72" alphatest="on" />
<ePixmap position="530,290" zPosition="7" size="19,16" pixmap="hd_glass16/icons/up.png" alphatest="on"/>
<widget name="Weather_Temperature4" font="Prive3;25" position="555,283" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<ePixmap position="530,325" zPosition="7" size="19,16" pixmap="hd_glass16/icons/down.png" alphatest="on"/>
<widget name="Weather_Temperaturelow4" font="Prive3;24" position="555,318" zPosition="2" size="75,40" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date4" font="Prive3;22" position="450,360" zPosition="3" size="200,50" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon5" pixmap="hd_glass16/icons/3200.png" position="890,255" zPosition="5" size="0,0" alphatest="on" />
<widget name="Weather_Temperaturelow5" font="Prive3;24" position="850,330" zPosition="2" size="0,0" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature5" font="Prive3;25" position="925,330" zPosition="2" size="0,0" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state5" font="Prive3;22" position="825,202" zPosition="3" size="0,0" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date5" font="Prive3;22" position="825,360" zPosition="3" size="0,0" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

</screen>"""

	skinLight2 = """<screen name="WeatherScreen" position="555,100" size="660,335" zPosition="8" title="Weather" backgroundColor="#31000000" >                                           
<widget name="Weather_sunrise" font="Prive3;22" position="850,158" zPosition="5" size="0,0" valign="top" halign="center" foregroundColor="#66CCFF" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_wind" pixmap="hd_glass16/icons/no-wind.png" position="650,40" zPosition="5" size="0,0" alphatest="on" />
<widget name="Weather_wind_label" font="Prive3;22" position="570,5" zPosition="2" size="0,0" valign="center" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_picon1" pixmap="hd_glass16/icons/3200.png" position="70,255" zPosition="5" size="0,0" alphatest="on" />
<widget name="Weather_state1" font="Prive3;22" position="5,202" zPosition="3" size="0,0" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date1" font="Prive3;22" position="5,360" zPosition="3" size="0,0" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_sunset" font="Prive3;22" position="10,0" zPosition="2" size="207,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature0" font="Prive3;40" position="20,40" zPosition="2" size="100,45" valign="top" halign="left" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_picon0" pixmap="hd_glass16/icons/3200.png" position="130,30" zPosition="5" size="72,72" alphatest="on" />
<widget name="Weather_state0" font="Prive3;17" position="10,105" zPosition="3" size="200,35" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<eLabel text="Max:" font="Prive3;18" position="15,140" zPosition="2" size="50,40" valign="top" halign="left" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature1" font="Prive3;18" position="70,140" zPosition="2" size="70,40" valign="top" halign="left" foregroundColor="red" backgroundColor="#31000000" transparent="1" />
<eLabel text="Min:" font="Prive3;18" position="130,140" zPosition="2" size="50,40" valign="top" halign="left" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperaturelow1" font="Prive3;18" position="185,140" zPosition="2" size="75,40" valign="top" halign="left" foregroundColor="blue" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_items" font="Prive3;17" position="250,5" zPosition="2" size="207,230" valign="top" halign="right" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_values" font="Prive3;17" position="467,5" zPosition="3" size="300,230" valign="top" halign="left"  backgroundColor="#31000000" transparent="1" />

<ePixmap position="5,175" zPosition="7" size="560,2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/setupGlass16/tib2.png" alphatest="on"/>
<ePixmap position="565,175" zPosition="7" size="460,2" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/setupGlass16/tib2.png" alphatest="on"/>

<widget name="Weather_state2" font="Prive3;17" position="10,180" zPosition="3" size="200,35" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_picon2" pixmap="hd_glass16/icons/3200.png" position="10,217" zPosition="5" size="72,72" alphatest="on" />
<ePixmap position="90,232" zPosition="7" size="19,16" pixmap="hd_glass16/icons/up.png" alphatest="on"/>
<widget name="Weather_Temperature2" font="Prive3;21" position="115,225" zPosition="2" size="75,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<ePixmap position="90,260" zPosition="7" size="19,16" pixmap="hd_glass16/icons/down.png" alphatest="on"/>
<widget name="Weather_Temperaturelow2" font="Prive3;21" position="115,253" zPosition="2" size="75,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date2" font="Prive3;17" position="10,294" zPosition="3" size="200,35" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_state3" font="Prive3;17" position="235,180" zPosition="3" size="200,35" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_picon3" pixmap="hd_glass16/icons/3200.png" position="235,217" zPosition="5" size="72,72" alphatest="on" />
<ePixmap position="315,232" zPosition="7" size="19,16" pixmap="hd_glass16/icons/up.png" alphatest="on"/>
<widget name="Weather_Temperature3" font="Prive3;21" position="340,225" zPosition="2" size="75,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<ePixmap position="315,260" zPosition="7" size="19,16" pixmap="hd_glass16/icons/down.png" alphatest="on"/>
<widget name="Weather_Temperaturelow3" font="Prive3;21" position="340,253" zPosition="2" size="75,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date3" font="Prive3;17" position="235,294" zPosition="3" size="200,35" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_state4" font="Prive3;17" position="450,180" zPosition="3" size="200,35" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_picon4" pixmap="hd_glass16/icons/3200.png" position="450,217" zPosition="5" size="72,72" alphatest="on" />
<ePixmap position="530,232" zPosition="7" size="19,16" pixmap="hd_glass16/icons/up.png" alphatest="on"/>
<widget name="Weather_Temperature4" font="Prive3;21" position="555,225" zPosition="2" size="75,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<ePixmap position="530,260" zPosition="7" size="19,16" pixmap="hd_glass16/icons/down.png" alphatest="on"/>
<widget name="Weather_Temperaturelow4" font="Prive3;21" position="555,253" zPosition="2" size="75,25" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date4" font="Prive3;17" position="450,294" zPosition="3" size="200,35" valign="top" halign="center"  foregroundColor="#EF3399" backgroundColor="#31000000" transparent="1" />

<widget name="Weather_picon5" pixmap="hd_glass16/icons/3200.png" position="665,185" zPosition="5" size="0,0" alphatest="on" />
<widget name="Weather_Temperaturelow5" font="Prive3;21" position="635,260" zPosition="2" size="0,0" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Temperature5" font="Prive3;21" position="700,260" zPosition="2" size="0,0" valign="top" halign="center" foregroundColor="yellow" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_state5" font="Prive3;16" position="625,150" zPosition="3" size="0,0" valign="center" halign="center"  foregroundColor="#00d100" backgroundColor="#31000000" transparent="1" />
<widget name="Weather_Date5" font="Prive3;16" position="625,285" zPosition="3" size="0,0" valign="top" halign="center"  foregroundColor="#CC3399" backgroundColor="#31000000" transparent="1" />

</screen>"""

	def __init__(self, session):
		Screen.__init__(self, session)
		self.skin = WeatherScreen.skin
		try:
			if LIGHT:		
				if "light" in config.plugins.setupGlass16.par12.value or "light" in config.plugins.setupGlass16.par78.value:
					self.skin = WeatherScreen.skinLight	
				else:
					self.skin = WeatherScreen.skinLight2	
			elif config.plugins.setupGlass16.par12.value == "Weather" or config.plugins.setupGlass16.par78.value == "Weather":		
				self.skin = WeatherScreen.skinB		
			if config.plugins.setupGlass16.par71.value:
				from keymapparser import readKeymap
				from GlobalActions import globalActionMap
				readKeymap("/usr/lib/enigma2/python/Plugins/Extensions/setupGlass16/keymap3.xml")
				globalActionMap.actions['eventNextPrev'] = self.changeCity
		except: pass
		self['Weather_items'] = Label(ALL_ITEMS)
		self['Weather_values'] = Label(RESET_VALUES)
		self['Weather_wind'] = Pixmap()
		self['Weather_wind_label'] = Label(_("Wind direction"))
		self['Weather_sunrise'] = Label(UNKNOWN_STATE)
		self['Weather_sunset'] = Label(UNKNOWN_STATE)		
		for x in range(0,6):
			self['Weather_picon%s' % x] = Pixmap()
			self['Weather_Temperature%s' % x] = ColorLabel(UNKNOWN_STATE_TEMP)
			if x != 0:
				self['Weather_Temperaturelow%s' % x] = ColorLabel(UNKNOWN_STATE_TEMP)
				self['Weather_Date%s' % x] = Label(UNKNOWN_STATE)
			self['Weather_state%s' % x] = Label(UNKNOWN_STATE)
		self.onShow.append(self.__wakeup)
		self.onHide.append(self.__standby)
		self.location = ""
		self.remainingTime = LEASE_TIME
		if "Weather" in config.plugins.setupGlass16.par78.value:
			from Components.ActionMap import ActionMap
			self["actions"] = ActionMap(["ColorActions", "SetupActions", "DirectionActions"],
			{
            "green": self.close,
            "red": self.close,
            "ok": self.close,
            "cancel": self.close,
            "yellow": self.close,
            "blue": self.close
			}, -2)            
                                                                     	
	def changeCity(self):
		config.plugins.setupGlass16.par13.handleKey(1)
		self.location = ""
		self.__wakeup()

	def __wakeup(self):
		def download_xml():
			os.system("rm -rf %s" % XML_FILE)
			chck = socket(AF_INET, SOCK_STREAM)
			chck.settimeout(1.0)
			try:
				if not bool(chck.connect_ex(('weather.yahoo.com', 80))):
					req = Request('http://weather.yahooapis.com/forecastrss?w=%s&u=c' % config.plugins.setupGlass16.par13.value)
					response = urlopen(req)
					data = response.read()
					response.close()
					localFile = open(XML_FILE, 'wb')
					localFile.write(data)
					localFile.close()
			except: pass
		def temperature_fix(temperature):
			tt = ""
			if temperature[0] != '-' and temperature[0] != '0':
				tt = '+'
			return tt + temperature + '%s' % unichr(176).encode("latin-1")
		def parse_line(line, what):
			def parse_AM_PM(txt):
				ttmp = txt.split(' ')
				ttmptxt = txt.replace('AM ','').replace('PM ','')
				if len(ttmp) == 2 and DICT_TEXT.has_key(ttmp[1]) and DICT_TEXT.has_key(ttmp[0]):
					return "%s %s" % (DICT_TEXT.get(ttmp[0]), DICT_TEXT.get(ttmp[1]))
				elif len(ttmp) == 3 and DICT_TEXT.has_key(ttmptxt) and DICT_TEXT.has_key(ttmp[0]):
					return "%s %s" % (DICT_TEXT.get(ttmp[0]), DICT_TEXT.get(ttmptxt))
				return txt
			txt = line.split(what)[1].split('"')[1]			
			if what == "day" and DICT_DAYS.has_key(txt):
				return DICT_DAYS.get(txt)
			elif what == "sunrise" or what == "sunset" :
				if "pm" in txt or "am" in txt:
					timeFull = txt.lower()
					txt = txt.replace(("pm").lower(),"").replace(("am").lower(),"").replace(" ","")
					time = txt.split(':')
					if "pm" in timeFull and not "12" in time[0]:
						return "%s:%s" % (int(time[0])+12, time[1])
					elif "am" in timeFull and "12" in time[0]:
						return "0:%s" % time[1]
					return txt
			elif what == "date":
				ttmp = txt.split(' ')
				if len(ttmp) == 3 and DICT_DATE.has_key(ttmp[1]):
					return "%s %s %s" % (ttmp[0], DICT_DATE.get(ttmp[1]), ttmp[2])
				elif len(ttmp) == 7 and DICT_DAYS.has_key(ttmp[0][:-1]) and DICT_DATE.has_key(ttmp[2]):
					timeFull = ttmp[4]
					time = ttmp[4].split(':')
					if "pm" in ttmp[5].lower() and not "12" in time[0]:
						timeFull = "%s:%s" % (int(time[0])+12, time[1])
					elif "am" in ttmp[5].lower() and "12" in time[0]:
						timeFull = "0:%s" % time[1]
					self.timeUpdate = "%s %s" % (timeFull, ttmp[6])
					return "%s, %s %s %s, %s %s" % (DICT_DAYS.get(ttmp[0][:-1]), ttmp[1], DICT_DATE.get(ttmp[2]), ttmp[3], timeFull, ttmp[6])
				else:
					return txt
			elif what == "text":
				txt = txt.replace(" Early","").replace(" Late","")
				if DICT_TEXT.has_key(txt):
					return DICT_TEXT.get(txt)
				elif ('am' in txt.lower() or 'pm' in txt.lower()) and not '/' in txt:
					return parse_AM_PM(txt)
 				elif '/' in txt:
					ttmp = txt.split('/')
					ret = ""
					for x in range(0, len(ttmp)):
						if DICT_TEXT.has_key(ttmp[x]):
							ret += "%s / " % DICT_TEXT.get(ttmp[x])
						elif 'am' in ttmp[x].lower() or 'pm' in ttmp[x].lower():
							ret += "%s / " % parse_AM_PM(ttmp[x])              
						else:
							ret += "%s / " % ttmp[x]
					if ret != "":
						return ret[:-3]
					return txt
			if txt != "":
				return txt
			else:
				return UNKNOWN_STATE
		def setColor(idx, temp, x=""):
			if temp < -10:			
				self['Weather_Temperature%s%s' % (x, idx)].color0()
			elif temp < -5:			
				self['Weather_Temperature%s%s' % (x, idx)].color1()
			elif temp < 5:			
				self['Weather_Temperature%s%s' % (x, idx)].color2()
			elif temp >= 40:
				self['Weather_Temperature%s%s' % (x, idx)].color10()
			elif temp >= 35:
				self['Weather_Temperature%s%s' % (x, idx)].color9()
			elif temp >= 30:
				self['Weather_Temperature%s%s' % (x, idx)].color8()
			elif temp >= 25:
				self['Weather_Temperature%s%s' % (x, idx)].color7()
			elif temp >= 20:
				self['Weather_Temperature%s%s' % (x, idx)].color6()
			elif temp >= 15:
				self['Weather_Temperature%s%s' % (x, idx)].color5()
			elif temp >= 10:
				self['Weather_Temperature%s%s' % (x, idx)].color4()
			elif temp >= 5:
				self['Weather_Temperature%s%s' % (x, idx)].color3()
		weather_dict = {'sunrise':UNKNOWN_STATE, 'sunset':UNKNOWN_STATE, 'wind_direction':UNKNOWN_STATE, 'templow5':UNKNOWN_STATE_TEMP, 'templow1':UNKNOWN_STATE_TEMP, 'templow2':UNKNOWN_STATE_TEMP, 'templow3':UNKNOWN_STATE_TEMP, 'templow4':UNKNOWN_STATE_TEMP, 'date5':UNKNOWN_STATE, 'date0':UNKNOWN_STATE, 'date1':UNKNOWN_STATE, 'date2':UNKNOWN_STATE, 'date3':UNKNOWN_STATE, 'date4':UNKNOWN_STATE, 'city':UNKNOWN_STATE, 'country':UNKNOWN_STATE, 'wind':UNKNOWN_STATE, 'humidity':UNKNOWN_STATE, 'visibility':UNKNOWN_STATE, 'pressure':UNKNOWN_STATE, 'text0':UNKNOWN_STATE, 'temp0':UNKNOWN_STATE_TEMP, 'picon0':"3200", 'text1':UNKNOWN_STATE, 'temp1':UNKNOWN_STATE_TEMP, 'picon1':"3200", 'text2':UNKNOWN_STATE, 'temp2':UNKNOWN_STATE_TEMP, 'picon2':"3200", 'text3':UNKNOWN_STATE, 'temp3':UNKNOWN_STATE_TEMP, 'picon3':"3200", 'text4':UNKNOWN_STATE, 'temp4':UNKNOWN_STATE_TEMP, 'picon4':"3200", 'text5':UNKNOWN_STATE, 'temp5':UNKNOWN_STATE_TEMP, 'picon5':"3200"}
		units_dict = {'wind':'', 'visibility':'', 'pressure':''}
		self.timeUpdate = UNKNOWN_STATE
		try:
			self.remainingTime = LEASE_TIME
			if config.plugins.setupGlass16.par13.value != "None":
				if self.location != config.plugins.setupGlass16.par13.value:
					download_xml()
				elif fileExists(XML_FILE):
					fileTime = int((time.time() - os.stat(XML_FILE).st_mtime)/60)
					if fileTime >= LEASE_TIME or os.path.getsize(XML_FILE) < 1000:
						download_xml()
					else:
						self.remainingTime = LEASE_TIME - fileTime
				else:
					download_xml()
					if not fileExists(XML_FILE):
						os.system("echo -e 'None' >> %s" % XML_FILE)
						self.resetWeather_values()
						return
			else:
				self.resetWeather_values()
				return			
		except: return
		if not fileExists(XML_FILE):
			os.system("echo -e 'None' >> %s" % XML_FILE)
			self.resetWeather_values()
			return
		idx = 1
		w_directPix = 'X'
		for line in open(XML_FILE):
			if line.find("<yweather:location") > -1:
				weather_dict['country'] = parse_line(line, 'country')
			elif line.find("<yweather:astronomy") > -1:
				weather_dict['sunrise'] = parse_line(line, 'sunrise')
				weather_dict['sunset'] = parse_line(line, 'sunset')
			elif line.find("<yweather:units") > -1:
				units_dict['wind'] = parse_line(line, 'speed')
				units_dict['visibility'] = parse_line(line, 'distance')
				units_dict['pressure'] = parse_line(line, 'pressure')
			elif line.find("<yweather:wind") > -1:
				try:
					weather_dict['wind'] = parse_line(line, 'speed')
					direct = int(parse_line(line, 'direction'))
					if direct >= 0 and direct <= 28:
						w_direct = _('N')
						w_directPix = 'N'
					elif direct >= 29 and direct <= 62:
						w_direct = _('NE')
						w_directPix = 'NE'
					elif direct >= 63 and direct <= 117:
						w_direct = _('E')
						w_directPix = 'E'
					elif direct >= 118 and direct <= 152:
						w_direct = _('SE')
						w_directPix = 'SE'
					elif direct >= 153 and direct <= 207:
						w_direct = _('S')
						w_directPix = 'S'
					elif direct >= 208 and direct <= 242:
						w_direct = _('SW')
						w_directPix = 'SW'
					elif direct >= 243 and direct <= 297:
						w_direct = _('W')
						w_directPix = 'W'
					elif direct >= 298 and direct <= 332:
						w_direct = _('NW')
						w_directPix = 'NW'
					else:
						w_direct = _('N')
						w_directPix = 'N'
					weather_dict['wind_direction'] = w_direct
				except: pass
			elif line.find("<yweather:atmosphere") > -1:
				weather_dict['humidity'] = parse_line(line, 'humidity') + ' %'
				weather_dict['visibility'] = parse_line(line, 'visibility')
				weather_dict['pressure'] = parse_line(line, 'pressure')
			elif line.find("<yweather:condition") > -1:
				try:
					weather_dict['date0'] = parse_line(line, 'date')
					weather_dict['text0'] = parse_line(line, 'text')
					weather_dict['picon0'] = parse_line(line, 'code')
					ttmp = parse_line(line, 'temp')
					weather_dict['temp0'] = temperature_fix(ttmp)
					setColor("0", int(ttmp))
				except: pass
			elif line.find("<yweather:forecast") > -1 and idx < 6:
				try:
					weather_dict['date%s' % idx] = "%s\n%s" % (parse_line(line, 'day'), parse_line(line, 'date'))
					weather_dict['text%s' % idx] = parse_line(line, 'text')
					weather_dict['picon%s' % idx] = parse_line(line, 'code')
					ttmp = parse_line(line, 'high')
					weather_dict['temp%s' % idx] = temperature_fix(ttmp)
					setColor(idx, int(ttmp))
					ttmp = parse_line(line, 'low')
					weather_dict['templow%s' % idx] = temperature_fix(ttmp)
					setColor(idx, int(ttmp), 'low')
					idx += 1
				except: pass
		try:
			weather_dict['city'] = config.plugins.setupGlass16.par13.getText()
			for x in ['wind', 'visibility', 'pressure']:
				if weather_dict['%s' % x] != UNKNOWN_STATE:
					weather_dict['%s' % x] += " " + units_dict['%s' % x]
			self['Weather_values'].setText("%s" % ({False:weather_dict['city'] + "\n" + weather_dict['country'] + "\n", True:""}[LIGHT]) + weather_dict['wind'] + "\n" + weather_dict['wind_direction'] + "\n" + weather_dict['humidity'] + "\n" + weather_dict['visibility'] + "\n" + weather_dict['pressure']+"%s" % ({False:"", True:"\n" + weather_dict['sunrise'] + "\n" + weather_dict['sunset'] + "\n" + self.timeUpdate}[LIGHT]))		
			self.setWindowTitle(weather_dict['date0'])
			if not LIGHT:
				path = config.plugins.setupGlass16.par39.value + "/piconWeather/" + str(config.plugins.setupGlass16.par72.value) + "/" + w_directPix + ".png"
				if not fileExists(path):
					path = NO_WIND_PICON
				self['Weather_wind'].instance.setPixmapFromFile(path)
				self['Weather_sunrise'].setText(weather_dict['sunrise'])
			self['Weather_sunset'].setText("%s" % ({False:weather_dict['sunset'], True:weather_dict['city']}[LIGHT]))
			for x in range(0,6):
				path = config.plugins.setupGlass16.par39.value + "/piconWeather/" + str(config.plugins.setupGlass16.par72.value) + "/" + weather_dict['picon%s' % x] + ".png"
				if not fileExists(path):
					path = NO_WEATHER_PICON
				self['Weather_picon%s' % x].instance.setPixmapFromFile(path)
				self['Weather_Temperature%s' % x].setText(weather_dict['temp%s' % x])
				self['Weather_state%s' % x].setText(weather_dict['text%s' % x])
				if x != 0:
					self['Weather_Date%s' % x].setText(weather_dict['date%s' % x])
					self['Weather_Temperaturelow%s' % x].setText(weather_dict['templow%s' % x])
		except: pass
    		
	def __standby(self):
		self.location = config.plugins.setupGlass16.par13.value        	  		

	def resetWeather_values(self):  		
		try:
			self.setWindowTitle(_('Weather'))
			self['Weather_values'].setText(RESET_VALUES)		
			self['Weather_wind'].instance.setPixmapFromFile(NO_WIND_PICON)
			self['Weather_sunrise'].setText(UNKNOWN_STATE)
			self['Weather_sunset'].setText(UNKNOWN_STATE)
			for x in range(0,6):
				self['Weather_picon%s' % x].instance.setPixmapFromFile(NO_WEATHER_PICON)
				self['Weather_Temperature%s' % x].setText(UNKNOWN_STATE_TEMP)		
				self['Weather_Temperature%s' % x].color4()
				self['Weather_state%s' % x].setText(UNKNOWN_STATE)
				if x != 0:
					self['Weather_Date%s' % x].setText(UNKNOWN_STATE)
					self['Weather_Temperaturelow%s' % x].setText(UNKNOWN_STATE_TEMP)		
					self['Weather_Temperaturelow%s' % x].color4()
		except: pass
    			
	def setWindowTitle(self, txt):
		if txt != _('Weather'):
			if LIGHT:
				txt = txt.replace(self.timeUpdate, "") + ' (%s min)' % self.remainingTime			
			else:
				txt += ', ' + _('time to reconnect')+': %s min' % self.remainingTime
		self.setTitle(txt)
		
